#!/usr/bin/perl

use Net::Telnet;
use strict;

my $host = shift;
my $match;
my $prematch;

my $t = new Net::Telnet (Timeout => 10);

$t->errmode("return");

$t->open( Host => $host, Port => 10118) || &end(2, "can't connect to ardaemon!");

if (($prematch, $match) = $t->waitfor(Match => "/greetings!\n/", Timeout => "10")) {
	#print "got greeting! yay!\n";
} else {
	&end(2, "timeout while waiting for greeting");
}


$t->print("stat\n");

if (($prematch, $match) = $t->waitfor(Match => "/status: /", Timeout => "10")) {
	# that's what we wanted!
} else {
	&end(2, "timeout while waiting for stat response");
}

my $statline = $t->lastline;
chomp $statline;

# not overly necessary, but we like to be nice!
$t->print("quit\n");

if ($statline =~ /^status: (\d+) clients/) {
	my $clientcnt = $1;
	#print "client count: $clientcnt\n";
	if ($clientcnt > 10) {
		&end(1, "client count ($clientcnt) is > 10, something might be wrong!");
	} elsif ($clientcnt > 20) {
		&end(2, "client count ($clientcnt) is > 20, something is probably wrong!");
	}
} else {
	&end(2, "something's wrong with the stat output.  call kitchen!");
}

&end(0, "ok! " . $statline);

sub end {
	print "$_[1]\n";
	exit $_[0];
}
print "hit the end.  busted plugin\n";
exit 2;
