#!/usr/bin/perl

use MIME::Base64;
use Expect;
use strict;

my $host = shift;

my $job = Expect->spawn("telnet $host 25") || die"couldn't exec telnet $host 25";
$job->log_stdout(0);

my $auth = encode_base64("mailtest\0mailtest\0aSdF9630");
chomp $auth;

$job->expect(30,'-re',".*220.*ESMTP.*");

print $job "ehlo test-mail\nauth plain $auth\n";

$job->expect(30,'-re',".*[2|5]35.*uthentication.*");

my $match = $job->exp_match;

if ( $match =~ /success|Authenticated/ ) {
	&end(0,"worked")
}

else {
	&end(2,"something went wrong logging in: $match");
}

sub end {
#	print "exiting with $_[0]\n";
	if ( $_[0] == 2 ) {
		print "$_[1]\n";
		$job->hard_close;
		exit 2;
	}
	else {
		print "mail's cool\n";
		$job->hard_close;
		exit 0;
	}
}
