#!/bin/bash
#
# Simple script to verify that the keepalived processes are running
# Unfortunately keepalived doesn't provide any type of monitoring interface
# To verify that it is working correclty :-/

pgrep=/usr/bin/pgrep
pidfile=/var/run/keepalived.pid

# Make sure master daemon is running
if [ -e $pidfile ] ; then 
  /bin/kill -0 `/bin/cat $pidfile`
  if [ "$?" -ne "0" ] ; then
    echo "CRITICAL - Keepalived master process did not respond to kill -0"
    exit 2
  fi
fi

# We fall through to check processes if kill works and if pid file doesn't exist"

keepalived=`$pgrep -c -f /usr/sbin/keepalived`
minprocs=3
maxprocs=4

if [ "$maxprocs" -ge  "$keepalived" -a  "$keepalived" -ge "$minprocs" ] ; then
  echo "OK - $keepalived Keepalived processes running"
  exit 0
else
  echo "CRITICAL - $keepalived processes running instead of 3-4"
  exit 2
fi
