#!/usr/bin/perl

my $load = `cat /proc/loadavg`;

my $warn1 = shift @ARGV;
my $crit1 = shift @ARGV;
my $warn5 = shift @ARGV;
my $crit5 = shift @ARGV;
my $warn15;
my $crit15;
if ($crit5) {
        $warn15 = shift @ARGV;
        $crit15 = shift @ARGV || die"usage: check_load.pl <wload1> <cload1> <wload5> <cload5> <wload15> <cload15>\n";
} else {
        if ($warn5) {
                $warn15=$warn5; $warn5=$crit1;
        } else {
                if ($crit1) {
                        $warn15= $crit1; $warn5=$warn1;
                } else {
                        die "usage: check_load.pl <cload5> <cload15>\n";
                }
        }
}

my ($load1,$load5,$load15) = split(' ',$load);

my $OnetoFive = undef;
if ( $load5 > 0 ) {
        $OnetoFive = (1 - ($load1 / $load5) ); #percentage of $load1 to $load5
}
my $FivetoFifteen = undef;
if ( $load15 > 0 ) {
        $FivetoFifteen = (1 - ($load5 / $load15) );
}

if (( $load5 < $warn5 ) || ( $load15 < $warn15 ) ) {
        print "$load1 $load5 $load15\n";
        exit 0;
}
else {  
        # Is load dropping?
        if ( ($load1 < $load5) && ($load5 < $load15) ) {
                #if it's not dropping more than 15%, we're still critical
                if( ( defined $OnetoFive && $OnetoFive < 0.15) || ( defined $FivetoFifteen && $FivetoFifteen <  0.15 ) ){
                        print "$load1 $load5 $load15\n";
                        exit 2;
                }
                else{   
                        #else we're just a warning
                        print "$load1 $load5 $load15\n";
                        exit 1;
                }
        }
        else{   
                print "$load1 $load5 $load15\n";
                exit 2;
        }
}


