#!/usr/bin/perl 
# # (c)1999 Mitch Wright, NetLine Corporation 
# Read the GNU copyright stuff for all the legalese # 
# Check to see that our MySQL server(s) are up and running. 
# This plugin requires that mysqladmin(1) is installed on the system. 
# Since it is part of the MySQL distribution, that should be a problem. #
# If no parameters are giving, a usage statement is output. # 
# Exit 0 on success, providing some informational output 
# Exit 2 on failure, provide what we can... #

require 5.004;
use strict;

my $TIMEOUT = 15;
my $MYSQLADMIN = "/etc/init.d/mysqld stat";

my %ERRORS = ('UNKNOWN' , '3',
              'OK' , '0',
              'WARNING', '1',
              'CRITICAL', '2');

my $state = "OK";
my $status;
# Just in case of problems, let's not hang NetSaint
$SIG{'ALRM'} = sub {
     print ("ERROR: No response from MySQL server (alarm)\n");
     exit $ERRORS{"UNKNOWN"};
};
alarm($TIMEOUT);

open (OUTPUT, "$MYSQLADMIN 2>&1 |");

while (<OUTPUT>) {
  if ($_ =~ /failed|error/i) { $state="CRITICAL"; s/.*://; $status=$_; last; }
}

print "state $state\nexit $ERRORS{$state}\n";
exit $ERRORS{$state};
