#!/usr/bin/perl

my $host = shift @ARGV;
my $warn = shift || 85;
my $crit = shift || 95;
my $count;
my %du;
my %iu;

#open(LOG,">> /tmp/netapp_df.log");
#print LOG "$host $warn $crit\n";
#close(LOG);


$ENV{'PATH'} = '/bin';
$ENV{'USER'} = 'root';
my $path = $ENV{'PATH'};

unless ($host =~ m/^([\d.]+)$/) {
	die"$host is an invalid ip address\n";
}
$host = $1;



open(C,"/usr/bin/rsh -l root $host df -i|");

# read the output

while (my $line = <C>) {
	next unless $line =~ /^\//;
	my ($vol,$iu,$if,$ipct,$mnt) = split(/\s+/,$line);
	next if $vol =~ /\.snapshot$/;
	$ipct =~ s/%//;
	$iu{"$vol"} = $ipct;
	if ( $ipct >= $crit ) {
		$crit = 1;
		push(@crit,$vol);
	}
	elsif ( $ipct >= $warn ) {
		$warn = 1;
		push(@warn,$vol);
	}
	$count++;
}
close(C);


open(C,"/usr/bin/rsh -l root $host df|");

# read the output

while (my $line = <C>) {
	next unless $line =~ /^\//;
	my ($vol,$size,$used,$free,$cap,$mnt) = split(/\s+/,$line);
	if ($vol =~ /\.snapshot$/) {
		$cap =~ s/\%//;
		$vol =~ s/\.snapshot//;
		$snapof{$vol} = $cap if ($cap > 100);
		next;
	}
	my $freeg = int($free / 10000) / 100;
	$du{"$vol"} = "$freeg" . "G free " . "($cap)";
	$cap =~ s/\%//;
	if ( $freeg > 100 ) {   # don't warn us if there's still more than 100 gigs free
		$count++;
		next;
	}
	elsif ( $cap >= $crit ) {
		$crit = 1;
		push(@crit,$vol);
	}
	elsif ( $ipct >= $warn ) {
		$warn = 1;
		push(@warn,$vol);
	}
	$count++;
}
close(C);



if ( $crit == 1 ) {
	foreach $v (@crit) {
		print $v . " " . $du{"$v"} . " " . $iu{"$v"} . "% inode usage ".($snapof{$v}?"(snap overflow)":"");
	}
	print "\n";
	exit 2;
}
elsif ( $warn == 1 ) {
	foreach $v (@warn) {
		print $v . " " . $du{"$v"} . " " . $iu{"$v"} . "% inode usage";
	}
	print "\n";
	exit 1;
}

# to catch errors because putting an OR after the open doesn't work in the case rsh can't connect...

if ( $count >= 2 ) {
	print "plenty of space to go around\n";
	exit 0;
}
else {
	print "something went wrong\n";
	exit -1;
}
