#!/usr/bin/perl

my $stat_file = "/var/cache/nagios3/status.dat";

unless ( open(STAT,$stat_file) ) {
	print "/var/cache/nagios3/status.dat dne. Is Nagios running?\n";
	exit 2;
}

my $start = 0;
my $last_command_check = 0;
my @last_checks;
my $now = time();

while ( <STAT> ) {
	$_ =~ s/^\s+//;
	if ( $_ =~ /^program_start/ ) {
		$_ =~ s/program_start\=//;
		$start = $_;
	}
	next unless $start;
	if ( $_ =~ /^last_command_check/ ) {
		$_ =~ s/last_command_check\=//;
		$last_command_check = $_;
		last;
	}
}
while (<STAT>) {
	$_ =~ s/^\s+//;
	if ($_ =~ /^last_check/) {
		$_ =~ s/last_check\=//;
		push @last_checks, $_;
	}
}
close(STAT);
my @sorted_last_checks = sort @last_checks;
my $last_check = pop @sorted_last_checks;
my $time_since_nagios_started = $now - $start;
my $time_since_last_check = $now - $last_check; 
my $time_since_last_command = $now - $last_command_check;

if ($time_since_nagios_started < (60*3) && $last_command_check == 0) {
	print "Nagios has been started or reloaded.  Giving it 3 minutes to run some checks\n";
	exit 0;
} elsif ($time_since_nagios_started > (60*3) && $last_command_check == 0) {
	print "Nagios hasn't executed a check in the last 3 minutes or updated a check in the last 3 minutes\n";
	exit 2;
} elsif ($time_since_last_check > (60*3) || $time_since_last_command > (60*3)) {
	print "Nagios hasn't executed a check in the last 3 minutes or updated a check in the last 3 minutes\n";
	exit 2;
} else {
	print "Nagios running fine, last check executed $time_since_last_command seconds ago and last check status updated $time_since_last_check seconds ago\n";
	exit 0;
}
